﻿Imports System.IO
Imports C1.WPF.Pdf
Imports System.Data

Class MainWindow

    Public Function MyDataTable() As DataTable
        Dim dtsource As New DataTable()
        ''Adding columns to datatable
        dtsource.Columns.Add("UserId")
        dtsource.Columns.Add("Name")
        dtsource.Columns.Add("Age")
        dtsource.Columns.Add("Address")
        dtsource.Columns.Add("Sex")
        dtsource.Columns.Add("DOB")
        dtsource.Columns.Add("Year")
        dtsource.Columns.Add("Designation")
        ''Adding records to the datatable
        dtsource.Rows.Add("1", "Name1", "20", "Address1", "Male", "20/12/1978", _
         "1978", "Student")
        dtsource.Rows.Add("2", "Name2", "21", "Address2", "Male", "20/12/1984", _
         "1984", "Doctor")
        dtsource.Rows.Add("3", "Name3", "22", "Address3", "Male", "10/11/1943", _
         "1943", "Software Eng.")
        dtsource.Rows.Add("4", "Name4", "23", "Address4", "Male", "12/12/1956", _
         "1956", "Police man")
        dtsource.Rows.Add("5", "Name5", "24", "Address5", "Male", "11/01/1856", _
         "1856", "CEO")
        dtsource.Rows.Add("6", "Name6", "25", "Address6", "Female", "29/12/2008", _
         "2008", "Manager")
        dtsource.Rows.Add("7", "Name7", "26", "Address7", "Female", "29/12/2004", _
         "2004", "Business man")
        dtsource.Rows.Add("8", "Name8", "27", "Address8", "Female", "29/12/1956", _
         "1956", "Student")
        dtsource.Rows.Add("9", "Name9", "28", "Address9", "Female", "15/10/2009", _
         "2009", "Project Manager")
        dtsource.Rows.Add("10", "Name10", "29", "Address10", "Female", "29/12/2010", _
         "2010", "Doctor")
        ''Adding records to the datatable
        dtsource.Rows.Add("1", "Name1", "20", "Address1", "Male", "20/12/1978", _
         "1978", "Student")
        dtsource.Rows.Add("2", "Name2", "21", "Address2", "Male", "20/12/1984", _
         "1984", "Doctor")
        dtsource.Rows.Add("3", "Name3", "22", "Address3", "Male", "10/11/1943", _
         "1943", "Software Eng.")
        dtsource.Rows.Add("4", "Name4", "23", "Address4", "Male", "12/12/1956", _
         "1956", "Police man")
        dtsource.Rows.Add("5", "Name5", "24", "Address5", "Male", "11/01/1856", _
         "1856", "CEO")
        dtsource.Rows.Add("6", "Name6", "25", "Address6", "Female", "29/12/2008", _
         "2008", "Manager")
        dtsource.Rows.Add("7", "Name7", "26", "Address7", "Female", "29/12/2004", _
         "2004", "Business man")
        dtsource.Rows.Add("8", "Name8", "27", "Address8", "Female", "29/12/1956", _
         "1956", "Student")
        dtsource.Rows.Add("9", "Name9", "28", "Address9", "Female", "15/10/2009", _
         "2009", "Project Manager")
        dtsource.Rows.Add("10", "Name10", "29", "Address10", "Female", "29/12/2010", _
         "2010", "Doctor")
        Return dtsource
    End Function

    '' export the grid to a PDF file
    Sub SavePdf(s As Stream, documentName As String)
        '' get root element to lay out the PDF pages
        Dim root As Panel = Nothing

        Dim _Parent As FrameworkElement = TryCast(c1Flexgrid1.Parent, FrameworkElement)

        While _Parent IsNot Nothing
            If TypeOf _Parent Is Panel Then
                root = TryCast(_Parent, Panel)
            End If

            _Parent = _Parent.Parent
        End While

        '' create pdf document
        Dim pdf As New C1PdfDocument(PaperKind.Letter, False)
        '' get page size
        Dim rc = pdf.PageRectangle
        Dim m = New Thickness(96, 96, 96 / 2, 96 / 2)
        Dim scaleMode = C1.WPF.FlexGrid.ScaleMode.ActualSize
        '' create panel to hold elements while they render
        Dim pageTemplate = New Printing.PageTemplate()
        pageTemplate.Width = rc.Width
        pageTemplate.Height = rc.Height
        pageTemplate.SetPageMargin(m)
        root.Children.Add(pageTemplate)
        '' render grid into PDF document
        Dim sz = New Size(rc.Width - m.Left - m.Right, rc.Height - m.Top - m.Bottom)
        Dim pages = c1Flexgrid1.GetPageImages(scaleMode, sz, 100)
        For i As Integer = 0 To (pages.Count - 1)
            '' skip a page when necessary
            If i > 0 Then
                pdf.NewPage()
            End If
            '' set content
            pageTemplate.PageContent.Child = pages(i)
            ''pageTemplate.PageContent.Stretch = System.Windows.Media.Stretch.Uniform;
            pageTemplate.PageContent.HorizontalAlignment = System.Windows.HorizontalAlignment.Stretch
            '' set header/footer text
            ''pageTemplate.HeaderLeft.Text = documentName;
            pageTemplate.FooterRight.Text = String.Format("Page {0} of {1}", i + 1, pages.Count)
            '' measure page element
            pageTemplate.Measure(New Size(rc.Width, rc.Height))
            pageTemplate.UpdateLayout()
            '' add page element to PDF
            pdf.DrawElement(pageTemplate, rc)
        Next
        '' done with template
        root.Children.Remove(pageTemplate)
        '' save the PDF document
        pdf.Save(s)
        s.Close()
    End Sub

    Private Sub Button_Click(sender As System.Object, e As System.Windows.RoutedEventArgs)
        Dim dlg = New Microsoft.Win32.SaveFileDialog()
        dlg.DefaultExt = "pdf"
        dlg.Filter = "PDF (*.pdf)|*.pdf"
        If dlg.ShowDialog().Value Then
            Using s = dlg.OpenFile()
                SavePdf(s, "ComponentOne PDF")
            End Using
        End If

    End Sub

    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        c1Flexgrid1.ItemsSource = MyDataTable().DefaultView
    End Sub
End Class
